#!/usr/bin/perl
#
# Turn on/off TurboPage and DNS Cache on HughesNet Modems
# 
# Warning, no guarantee is made of what this does, or if
# it is safe or legal to perform this operation.  It is
# Dangerous to use this script and may break your Internet
# Connection, BE WARNED!!!
#
# Script by BitByteBit (C) 2007 GPL'ed http://www.gnu.org

# Input Variables: username, password, [enable/disable]

# import module
use Getopt::Long;
 

$TURBOMODE = ""; # (1=disable, 2=enable)
$DNSCACHEMODE = ""; # (1=disable, 2=enable)

## Hughes Net Modem IP
$ftpserver = "";

# Put username, password for Modem 
# below here, you can find it at
# http://www.dslreports.com/forum/r18347368-
# or just search for it on the Internet ;).

##Login username
$ftpusername = "";

##Login password
$ftppass = "";

$turbo = "on";
$dnscache = "off";

$help = 0;

# get value of input flags
$result = GetOptions (
	"ftpusername|u=s" => \$ftpusername, 
	"ftppass|p=s" => \$ftppass, 
	"turbo|t=s" => \$turbo,
	"dnscache|d=s" => \$dnscache,
	"ftpserver|s=s" => \$ftpserver,
	"help|h" => \$help);  

if ($help == 1) {
  print "\n";
  print "WARNING!!! THIS IS DANGEROUS, USE AT YOUR OWN RISK!!!! There is no gurantee this will do anything at all\n";
  print " You first must figure out the username/password for your HughesNet Modem\n";
  print " Username/Password may be at: http://www.dslreports.com/forum/r18347368-  ;)\n";
  print " should work on most Hughesnet DW**** modems, only tested on DW7000\n";
  print " check if you have the /cfg0/config/ directory and QA, QD config files if not a DW7000!\n";
  print "  BitByteBit (C) 2007 GNU GPLed http://www.gnu.org\n";
  print "\n";
  print "USAGE: -s MODEMIP -u FTPUSERNAME -p FTPPASSWORD -t [on|off] -d [on|off]\n";
  print "       FTPUSERNAME = username to login to DW**** Modem\n";
  print "       FTPPASSWORD = password to login to DW**** Modem\n";
  print "       MODEMIP     = ip address of the DW**** Modem\n";
  print "       [on|off]    = on enables TurboPage, off disables it\n";
  print "       [on|off]    = on enables DNS Cache, off disables it\n";
  print "\n";
  print " Example:   ftp_dw7000.pl -s 192.168.0.1 -u myusername -p mypassword -t on -d off   (turns on TP and turns DNS Cache off)\n";
  print "\n";
  print " You can disable TurboPage and DNS Caching permanently, till you use this\n";
  print " to set them up again or HughesNet upgrades you modem software.  This allows\n";
  print " you to fully use OpenDNS after disabling those two cache/turbo settings!\n\n";
  exit(0);
}

# Turbo Mode ON?
if ($turbo eq "on") {
  $TURBOMODE = "2"; # Enable
  print "Enabling Turbo MODE for $ftpserver using user=$ftpusername pass=$ftppass\n";
} elsif ($turbo eq "off") {
  $TURBOMODE = "1";
  print "Disabling Turbo MODE for $ftpserver using user=$ftpusername pass=$ftppass\n";
} else {
  print "Error with turbo argument, must be either 'on' or 'off'!!!\n";
  exit(1);
}

# DNS Cache Mode ON?
if ($dnscache eq "on") {
  $DNSCACHEMODE = "2"; # Enable
  print "Enabling DNS Cache for $ftpserver using user=$ftpusername pass=$ftppass\n";
} elsif ($dnscache eq "off") {
  $DNSCACHEMODE = "1";
  print "Disabling DNS Cache for $ftpserver using user=$ftpusername pass=$ftppass\n";
} else {
  print "Error with dnscache argument, must be either 'on' or 'off'!!!\n";
  exit(1);
}

if ($ftpserver eq "") {
  print "Must supply modem IP!!!\n";
  exit(1);
}

if ($ftpusername eq "") {
  print "Must supply ftp username!!!\n";
  exit(1);
}

if ($ftppass eq "") {
  print "Must supply ftp password!!!\n";
  exit(1);
}

##Config Files folder on Modem (no trailing slash)
$cwdd = "/cfg0/config";

##TurboPage and DNS Cache Config Files
$qdfile = "QD";
$qafile = "QA";

##NO NEED TO EDIT ANYTHING BELOW THIS LINE

use Net::FTP;

if ($ftp = Net::FTP->new("$ftpserver", Debug => 0)) { 
  print "Logging in to HughesNet Modem at $ftpserver\n"; 
} else { 
  print "could not find Modem at $ftpserver! Exiting\n";
  exit(1); 
}

if ($ftp->login("$ftpusername","$ftppass")) { 
  print "Username and Password ACCEPTED\n"; 
} else { 
  print "could not log into server with Username and Password, must be the wrong ones!!! Exiting!\n"; 
  exit(1); 
}

if ($ftp->pasv) { 
  print "Passive mode entered successfully\n"; 
} else {
  print "Could not switch to pasive mode.\n"; 
}

if ($ftp->cwd("$cwdd")) { 
  print "Changed to the directory $cwdd without any trouble - DOWNLOADING Config Files QA and QD\n"; 
} else { 
  print "Could not change to the appropriate directory, exiting!!!\n"; 
  exit(1); 
}

if ($ftp->binary) { 
  print "Changed to BINARY Mode No Problem\n"; 
} else {
  print "Could not change to BINARY mode $!\n"; 
  exit(1); 
}

if ($ftp->get("$qdfile","$qdfile")) { 
  print "Everything appears ok with the Transfer of QD File\n"; 
} else { 
  print "Can not Transfer QD file $!\n EXITING\n", $ftp->message, "\n"; 
  exit(1); 
}

if ($ftp->get("$qafile","$qafile")) { 
  print "Everything appears ok with the Transfer of QA File\n"; 
} else { 
  print "Can not Transfer QA file $!\n EXITING\n", $ftp->message, "\n"; 
  exit(1); 
}

# Edit QA File (turbo page disable)
print "Changing config option tpcCfEnabled= in QA file to $TURBOMODE\n";
open IN, "<$qafile"
  or die "Cannot open: $!";
open OUT, ">$qafile~"
  or die "Cannot create: $!";
while (<IN>) {
  if ($_ =~ /^tpcCfEnabled/) {
    print OUT "tpcCfEnabled=$TURBOMODE\n";
  } else {
    print OUT "$_";
  }
}
close IN;
close OUT;
rename "$qafile~", "$qafile"
          or die "Cannot rename: $!";

print "Changing config option dnsCfProxyEnabled= in QD file to $DNSCACHEMODE\n";
# Edit QD File (dns cache disable)
open IN, "<$qdfile"
  or die "Cannot open: $!";
open OUT, ">$qdfile~"
  or die "Cannot create: $!";
while (<IN>) {
  if ($_ =~ /^dnsCfProxyEnabled/) {
    print OUT "dnsCfProxyEnabled=$DNSCACHEMODE\n";
  } else {
    print OUT "$_";
  }
}
close IN;
close OUT;
rename "$qdfile~", "$qdfile"
          or die "Cannot rename: $!";

# Upload new config files with services disabled
if ($ftp->put("$qafile","$qafile")) { 
  print "Everything appears ok with the Upload of the QA file\n"; 
} else { 
  print "Can not Transfer QA file $!\n EXITING\n", $ftp->message, "\n"; 
  exit(1); 
}

if ($ftp->put("$qdfile","$qdfile")) { 
  print "Everything appears ok with the Upload of the QD file\n"; 
} else { 
  print "Can not Transfer QD file $!\n EXITING\n", $ftp->message, "\n"; 
  exit(1); 
}

if (-f "$qdfile") {
  unlink("$qdfile");
}
if (-f "$qafile") {
  unlink("$qafile");
}

# Quit FTP
$ftp->quit;

# Done!
print "Modem Reconfigured with TurboMode set to $turbo and DNS Cache set to $dnscache, Transfer OK!\nReboot your Modem to activate new configuration.\n";

